#!/usr/local/bin/ruby
#
# parser benchmark
#

require 'tmail'
require 'loader'


if ARGV.size == 0 then
  puts "usage: Test4.rb <mhdir> <mhdir>..."
  exit 0
end
ARGV.each do |dn|
  unless File.exist? dn then
    puts "directory #{dn} is not exist."
    exit 1
  end
end

$stdout.sync = true

$count   = 0
$failnum = 0
$dirfail = 0
$fieldname = ''
$dirname   = ''
$port  = nil

begin
  ARGV.each do |dirname|
    dirname = File.expand_path( dirname )
    $dirname = dirname

    MhLoader.new( dirname ).each do |port|
      begin
        t = TMail.new( port )
        $port = port

        t.each do |key, field|
          next if /received/io === key
          $fieldname = key
          field.parse
        end
      rescue ParseError
        $stderr.puts "fail in #{$filename}, field #{$fieldname}"
        $stderr.puts $!.to_s
        $failnum += 1
        $dirfail += 1

        if $failnum % 10 == 0 then
          puts 'fail = ' + $failnum.to_s
          #raise
        end
      end

      $count += 1
      puts "end #{$count}" if $count % 50 == 0
    end

    puts "directory #{dirname} end, fail=#{$dirfail}"
    $dirfail = 0
  end
rescue
  puts "at #{$port.inspect}, non ParseError raised"
  raise
end

puts "parse #{$count} files, fail=#{$failnum}"
